#Error Analysis

#import python modules
import numpy as np
import sys

def ReadFile(File):
    """Returns an array of the alpha carbon positions and a list with the corresponding three-letter code"""    
    data=[]
    for line in file(File, "r").readlines():
        if not line.startswith("#"):
            linenew = line.split()
            # collects the radius of gyration data from the input file after the run has equilibrated
            if int(linenew[0]) >= 50000:
                data.append(linenew[5])
    data = np.array(data,float)
    return data

File = sys.argv[1]
data = ReadFile(File)
Avg = data.mean()
Var = data.var()
print "#Mean is: %8.6f" % Avg
print "#Var is: %8.6f" % Var

tau = len(data)
print "#Tau is: %d" % tau

taub = range(5,500,5)

for j in taub:
   nb = tau/(j*j)
   block = np.zeros(nb, dtype=float)
   # Compute block averages for a variety of block lengths
   for i in range(nb):
       block[i] = (data[(i*j*j):(((i+1)*j*j))].mean() - Avg) ** 2.0
   # The value of 10 is since only every 10 data points are collected.
   print "%8.6f %8.6f" % (j,(10*j*j*block.mean()/Var))


# When the data from the output file is graphed, the plateau value is the number of simulation steps
# that are uncorrelated, which can be used to calculate the actual standard deviation.

